<%--
/**
 * Copyright (c) 2000-present Liferay, Inc. All rights reserved.
 *
 * The contents of this file are subject to the terms of the Liferay Enterprise
 * Subscription License ("License"). You may not use this file except in
 * compliance with the License. You can obtain a copy of the License by
 * contacting Liferay, Inc. See the License for the specific language governing
 * permissions and limitations under the License, including but not limited to
 * distribution rights of the Software.
 *
 *
 *
 */
--%>

<%@ include file="/card/horizontal_card/init.jsp" %>

<c:choose>
	<c:when test="<%= (rowChecker != null) && (resultRow != null) %>">
		<liferay-util:buffer var="checkboxInput">
			<%= rowChecker.getRowCheckBox(request, rowChecker.isChecked(resultRow.getObject()), rowChecker.isDisabled(resultRow.getObject()), resultRow.getPrimaryKey()) %>
		</liferay-util:buffer>

		<c:if test="<%= Validator.isNotNull(checkboxInput) %>">
			<div class="checkbox checkbox-card checkbox-middle-left">
				<label>
					<%= checkboxInput %>
		</c:if>
	</c:when>
	<c:when test="<%= showCheckbox %>">
		<div class="checkbox checkbox-card checkbox-middle-left">
			<label>
				<aui:input checked="<%= checkboxChecked %>" cssClass="<%= checkboxCSSClass %>" data="<%= checkboxData %>" disabled="<%= checkboxDisabled %>" id="<%= checkboxId %>" label="" name="<%= checkboxName %>" title='<%= LanguageUtil.format(request, "select-x", new Object[] {HtmlUtil.escape(text)}) %>' type="checkbox" useNamespace="<%= false %>" value="<%= checkboxValue %>" wrappedField="<%= true %>" />
	</c:when>
</c:choose>

<div class="card card-horizontal taglib-horizontal-card <%= Validator.isNotNull(cssClass) ? cssClass : StringPool.BLANK %>" <%= AUIUtil.buildData(data) %>>
	<div class="card-row card-row-padded <%= showCheckbox ? "selectable" : StringPool.BLANK %>">
		<c:if test="<%= Validator.isNotNull(colHTML) %>">
			<div class="card-col-field">
				<%= colHTML %>
			</div>
		</c:if>

		<div class="card-col-content card-col-gutters">
			<span class="lfr-card-title-text truncate-text">
				<aui:a data="<%= linkData %>" href="<%= url %>" label="<%= HtmlUtil.escape(text) %>" title="<%= HtmlUtil.escapeAttribute(text) %>" />
			</span>
		</div>

		<liferay-util:buffer var="actionJspBuffer">
			<liferay-util:include page="<%= actionJsp %>" servletContext="<%= actionJspServletContext %>" />
		</liferay-util:buffer>

		<c:if test="<%= Validator.isNotNull(actionJspBuffer) %>">
			<div class="card-col-field lfr-card-actions-column">
				<%= actionJspBuffer %>
			</div>
		</c:if>
	</div>
</div>

<c:choose>
	<c:when test="<%= (rowChecker != null) && (resultRow != null) %>">
		<liferay-util:buffer var="checkboxInput">
			<%= rowChecker.getRowCheckBox(request, rowChecker.isChecked(resultRow.getObject()), rowChecker.isDisabled(resultRow.getObject()), resultRow.getPrimaryKey()) %>
		</liferay-util:buffer>

		<c:if test="<%= Validator.isNotNull(checkboxInput) %>">
				</label>
			</div>
		</c:if>
	</c:when>
	<c:when test="<%= showCheckbox %>">
			</label>
		</div>
	</c:when>
</c:choose>