<%--
/**
 * Copyright (c) 2000-present Liferay, Inc. All rights reserved.
 *
 * The contents of this file are subject to the terms of the Liferay Enterprise
 * Subscription License ("License"). You may not use this file except in
 * compliance with the License. You can obtain a copy of the License by
 * contacting Liferay, Inc. See the License for the specific language governing
 * permissions and limitations under the License, including but not limited to
 * distribution rights of the Software.
 *
 *
 *
 */
--%>

<%@ taglib uri="http://liferay.com/tld/aui" prefix="aui" %>
<%@ taglib uri="http://liferay.com/tld/frontend" prefix="liferay-frontend" %>
<%@ taglib uri="http://liferay.com/tld/theme" prefix="liferay-theme" %>
<%@ taglib uri="http://liferay.com/tld/ui" prefix="liferay-ui" %>

<%@ page import="com.liferay.layout.admin.web.internal.constants.LayoutAdminPortletKeys" %>
<%@ page import="com.liferay.portal.kernel.language.LanguageUtil" %>
<%@ page import="com.liferay.portal.kernel.model.Group" %>
<%@ page import="com.liferay.portal.kernel.util.HtmlUtil" %>
<%@ page import="com.liferay.portal.kernel.util.PortalUtil" %>

<%@ page import="javax.portlet.PortletRequest" %>
<%@ page import="javax.portlet.PortletURL" %>

<liferay-frontend:defineObjects />

<liferay-theme:defineObjects />

<%
String portletId = LayoutAdminPortletKeys.GROUP_PAGES;

Group group = themeDisplay.getScopeGroup();

if (group.isLayoutPrototype()) {
	portletId = LayoutAdminPortletKeys.LAYOUT_PROTOTYPE_PAGE;
}

PortletURL editPageURL = PortalUtil.getControlPanelPortletURL(request, portletId, PortletRequest.RENDER_PHASE);

editPageURL.setParameter("backURL", PortalUtil.getCurrentURL(request));
editPageURL.setParameter("groupId", String.valueOf(layout.getGroupId()));
editPageURL.setParameter("selPlid", String.valueOf(layout.getPlid()));
editPageURL.setParameter("privateLayout", String.valueOf(layout.isPrivateLayout()));
%>

<li class="control-menu-nav-item">
	<a class="control-menu-icon lfr-portal-tooltip" data-qa-id="editLayout" data-title="<%= HtmlUtil.escape(LanguageUtil.get(resourceBundle, "configure-page")) %>" href="<%= editPageURL.toString() %>">
		<aui:icon cssClass="icon-monospaced" image="cog" markupView="lexicon" />
	</a>
</li>

<liferay-ui:success key="layoutUpdated" message='<%= LanguageUtil.get(resourceBundle, "the-page-was-updated-succesfully") %>' targetNode="#controlMenuAlertsContainer" />