<%--
/**
 * Copyright (c) 2000-present Liferay, Inc. All rights reserved.
 *
 * The contents of this file are subject to the terms of the Liferay Enterprise
 * Subscription License ("License"). You may not use this file except in
 * compliance with the License. You can obtain a copy of the License by
 * contacting Liferay, Inc. See the License for the specific language governing
 * permissions and limitations under the License, including but not limited to
 * distribution rights of the Software.
 *
 *
 *
 */
--%>

<%@ include file="/document_library/init.jsp" %>

<%
FileEntry fileEntry = (FileEntry)request.getAttribute("info_panel.jsp-fileEntry");

int status = WorkflowConstants.STATUS_APPROVED;

if ((user.getUserId() == fileEntry.getUserId()) || permissionChecker.isContentReviewer(user.getCompanyId(), scopeGroupId)) {
	status = WorkflowConstants.STATUS_ANY;
}

List<FileVersion> fileVersions = fileEntry.getFileVersions(status);

for (FileVersion fileVersion : fileVersions) {
	request.setAttribute("info_panel.jsp-fileVersion", fileVersion);
%>

	<aui:row>
		<aui:col width="<%= 100 %>">
			<ul class="sidebar-header-actions">
				<li>
					<liferay-util:include page="/document_library/file_entry_history_action.jsp" servletContext="<%= application %>" />
				</li>
			</ul>

			<dl>
				<dt class="h5">
					<liferay-ui:message arguments="<%= fileVersion.getVersion() %>" key="version-x" />
				</dt>
				<dd>
					<c:choose>
						<c:when test="<%= Validator.isNull(fileVersion.getChangeLog()) %>">
							<small class="text-muted">
								<liferay-ui:message key="no-change-log" />
							</small>
						</c:when>
						<c:otherwise>
							<%= fileVersion.getChangeLog() %>
						</c:otherwise>
					</c:choose>
				</dd>
			</dl>
		</aui:col>
	</aui:row>

<%
}
%>