<%--
/**
 * Copyright (c) 2000-present Liferay, Inc. All rights reserved.
 *
 * The contents of this file are subject to the terms of the Liferay Enterprise
 * Subscription License ("License"). You may not use this file except in
 * compliance with the License. You can obtain a copy of the License by
 * contacting Liferay, Inc. See the License for the specific language governing
 * permissions and limitations under the License, including but not limited to
 * distribution rights of the Software.
 *
 *
 *
 */
--%>

<%@ include file="/management_bar_sidenav_toggler_button/init.jsp" %>

<liferay-frontend:management-bar-button
	active="<%= false %>"
	cssClass="<%= cssClass %>"
	data="<%= data %>"
	disabled="<%= disabled %>"
	href="<%= href %>"
	icon="<%= icon %>"
	iconCssClass="<%= iconCssClass %>"
	id="<%= id %>"
	label="<%= label %>"
/>

<aui:script use="liferay-store">
	var sidenavToggle = $('[href="#<%= sidenavId %>"]');

	if (!sidenavToggle.sideNavigation('instance')) {
		sidenavToggle.sideNavigation(
			{
				position: '<%= position %>',
				type: '<%= type %>',
				typeMobile: '<%= typeMobile %>',
				width: '<%= width %>'
			}
		);

		var sidenavSlider = $('#<%= sidenavId %>');

		sidenavSlider.on(
			'closed.lexicon.sidenav',
			function(event) {
				Liferay.Store('com.liferay.info.panel_<%= sidenavId %>', 'closed');
			}
		);

		sidenavSlider.on(
			'open.lexicon.sidenav',
			function(event) {
				Liferay.Store('com.liferay.info.panel_<%= sidenavId %>', 'open');
			}
		);
	}
</aui:script>