<%--
/**
 * Copyright (c) 2000-present Liferay, Inc. All rights reserved.
 *
 * The contents of this file are subject to the terms of the Liferay Enterprise
 * Subscription License ("License"). You may not use this file except in
 * compliance with the License. You can obtain a copy of the License by
 * contacting Liferay, Inc. See the License for the specific language governing
 * permissions and limitations under the License, including but not limited to
 * distribution rights of the Software.
 *
 *
 *
 */
--%>

<%@ include file="/init.jsp" %>

<%
SearchContainer searchContainer = (SearchContainer)request.getAttribute(WebKeys.SEARCH_CONTAINER);

String toolbarItem = ParamUtil.getString(request, "toolbarItem");

long groupId = ParamUtil.getLong(request, "groupId", scopeGroupId);
long classNameId = ParamUtil.getLong(request, "classNameId");
long classPK = ParamUtil.getLong(request, "classPK");
long resourceClassNameId = ParamUtil.getLong(request, "resourceClassNameId");

String message = "add";
%>

<liferay-frontend:add-menu>
	<c:choose>
		<c:when test="<%= classNameId == PortalUtil.getClassNameId(DDMStructure.class) %>">
			<c:if test="<%= DDMTemplatePermission.containsAddTemplatePermission(permissionChecker, groupId, classNameId, scopeClassNameId) && (Validator.isNull(templateTypeValue) || templateTypeValue.equals(DDMTemplateConstants.TEMPLATE_TYPE_FORM)) %>">

				<%
				if (Validator.isNull(templateTypeValue)) {
					message = "add-form-template";
				}
				%>

				<portlet:renderURL copyCurrentRenderParameters="<%= false %>" var="addTemplateURL">
					<portlet:param name="mvcPath" value="/edit_template.jsp" />
					<portlet:param name="groupId" value="<%= String.valueOf(groupId) %>" />
					<portlet:param name="classNameId" value="<%= String.valueOf(classNameId) %>" />
					<portlet:param name="classPK" value="<%= String.valueOf(classPK) %>" />
					<portlet:param name="resourceClassNameId" value="<%= String.valueOf(resourceClassNameId) %>" />
					<portlet:param name="structureAvailableFields" value='<%= renderResponse.getNamespace() + "getAvailableFields" %>' />
				</portlet:renderURL>

				<liferay-frontend:add-menu-item
					title="<%= LanguageUtil.get(request, message) %>"
					url="<%= addTemplateURL %>"
				/>
			</c:if>

			<c:if test="<%= DDMTemplatePermission.containsAddTemplatePermission(permissionChecker, groupId, classNameId, scopeClassNameId) && (Validator.isNull(templateTypeValue) || templateTypeValue.equals(DDMTemplateConstants.TEMPLATE_TYPE_DISPLAY)) %>">

				<%
				if (Validator.isNull(templateTypeValue)) {
					message = "add-display-template";
				}
				%>

				<portlet:renderURL copyCurrentRenderParameters="<%= false %>" var="addTemplateURL">
					<portlet:param name="mvcPath" value="/edit_template.jsp" />
					<portlet:param name="groupId" value="<%= String.valueOf(groupId) %>" />
					<portlet:param name="classNameId" value="<%= String.valueOf(classNameId) %>" />
					<portlet:param name="classPK" value="<%= String.valueOf(classPK) %>" />
					<portlet:param name="resourceClassNameId" value="<%= String.valueOf(resourceClassNameId) %>" />
					<portlet:param name="type" value="<%= DDMTemplateConstants.TEMPLATE_TYPE_DISPLAY %>" />
				</portlet:renderURL>

				<liferay-frontend:add-menu-item
					title="<%= LanguageUtil.get(request, message) %>"
					url="<%= addTemplateURL %>"
				/>
			</c:if>
		</c:when>
		<c:otherwise>

			<%
			List<TemplateHandler> templateHandlers = new ArrayList<TemplateHandler>();

			if (classNameId > 0) {
				TemplateHandler templateHandler = TemplateHandlerRegistryUtil.getTemplateHandler(classNameId);

				if (PortletPermissionUtil.contains(permissionChecker, layout, templateHandler.getResourceName(), ActionKeys.ADD_PORTLET_DISPLAY_TEMPLATE)) {
					templateHandlers.add(templateHandler);
				}
			}
			else {
				templateHandlers = PortletDisplayTemplateUtil.getPortletDisplayTemplateHandlers();

				Iterator<TemplateHandler> itr = templateHandlers.iterator();

				while (itr.hasNext()) {
					TemplateHandler templateHandler = itr.next();

					if (!PortletPermissionUtil.contains(permissionChecker, layout, templateHandler.getResourceName(), ActionKeys.ADD_PORTLET_DISPLAY_TEMPLATE)) {
						itr.remove();
					}
				}
			}

			if (!templateHandlers.isEmpty()) {
				ListUtil.sort(templateHandlers, new TemplateHandlerComparator(locale));
			%>

				<liferay-portlet:renderURL copyCurrentRenderParameters="<%= false %>" varImpl="addPortletDisplayTemplateURL">
					<portlet:param name="mvcPath" value="/edit_template.jsp" />
					<portlet:param name="groupId" value="<%= String.valueOf(groupId) %>" />
					<portlet:param name="type" value="<%= DDMTemplateConstants.TEMPLATE_TYPE_DISPLAY %>" />
				</liferay-portlet:renderURL>

				<%
				for (TemplateHandler templateHandler : templateHandlers) {
					addPortletDisplayTemplateURL.setParameter("classNameId", String.valueOf(PortalUtil.getClassNameId(templateHandler.getClassName())));
					addPortletDisplayTemplateURL.setParameter("classPK", String.valueOf(0));
					addPortletDisplayTemplateURL.setParameter("resourceClassNameId", String.valueOf(resourceClassNameId));
				%>

					<liferay-frontend:add-menu-item
						title="<%= templateHandler.getName(locale) %>"
						url="<%= addPortletDisplayTemplateURL.toString() %>"
					/>

			<%
				}
			}
			%>

		</c:otherwise>
	</c:choose>
</liferay-frontend:add-menu>