<%--
/**
 * Copyright (c) 2000-present Liferay, Inc. All rights reserved.
 *
 * The contents of this file are subject to the terms of the Liferay Enterprise
 * Subscription License ("License"). You may not use this file except in
 * compliance with the License. You can obtain a copy of the License by
 * contacting Liferay, Inc. See the License for the specific language governing
 * permissions and limitations under the License, including but not limited to
 * distribution rights of the Software.
 *
 *
 *
 */
--%>

<%@ include file="/init.jsp" %>

<%
DDLRecord record = (DDLRecord)request.getAttribute(DDLWebKeys.DYNAMIC_DATA_LISTS_RECORD);

DateSearchEntry dateSearchEntry = new DateSearchEntry();

List<DDLRecordVersion> recordVersions = DDLRecordVersionServiceUtil.getRecordVersions(record.getRecordId());

for (DDLRecordVersion recordVersion : recordVersions) {
	dateSearchEntry.setDate(recordVersion.getCreateDate());

	request.setAttribute(DDLWebKeys.DYNAMIC_DATA_LISTS_RECORD_VERSION, recordVersion);
%>

	<div>
		<ul class="sidebar-header-actions">
			<li>
				<liferay-util:include page="/record_version_action.jsp" servletContext="<%= application %>" />
			</li>
		</ul>

		<h4><liferay-ui:message arguments="<%= recordVersion.getVersion() %>" key="version-x" /></h4>

		<p>
			<small class="text-muted">
				<liferay-ui:message key="author" />: <%= recordVersion.getUserName() %>
			</small>
		</p>

		<p>
			<small class="text-muted">
				<liferay-ui:message key="create-date" />: <%= dateSearchEntry.getName(request) %>
			</small>
		</p>
	</div>

	<%} %>