<%--
/**
 * Copyright (c) 2000-present Liferay, Inc. All rights reserved.
 *
 * The contents of this file are subject to the terms of the Liferay Enterprise
 * Subscription License ("License"). You may not use this file except in
 * compliance with the License. You can obtain a copy of the License by
 * contacting Liferay, Inc. See the License for the specific language governing
 * permissions and limitations under the License, including but not limited to
 * distribution rights of the Software.
 *
 *
 *
 */
--%>

<%@ include file="/wiki/init.jsp" %>

<%
WikiNode node = (WikiNode)request.getAttribute(WikiWebKeys.WIKI_NODE);

String navigation = ParamUtil.getString(request, "navigation", "all-pages");

String orderByCol = GetterUtil.getString((String)request.getAttribute("view_pages.jsp-orderByCol"));
String orderByType = GetterUtil.getString((String)request.getAttribute("view_pages.jsp-orderByType"));

PortletURL portletURL = renderResponse.createRenderURL();

portletURL.setParameter("mvcRenderCommandName", "/wiki/view_pages");
portletURL.setParameter("redirect", currentURL);
portletURL.setParameter("nodeId", String.valueOf(node.getNodeId()));
portletURL.setParameter("navigation", navigation);

Map<String, String> orderColumns = new HashMap<String, String>();

orderColumns.put("modifiedDate", "modified-date");
orderColumns.put("title", "title");
%>

<liferay-frontend:management-bar-navigation
	navigationKeys='<%= new String[] {"all-pages", "draft-pages", "frontpage", "orphan-pages", "recent-changes"} %>'
	portletURL="<%= PortletURLUtil.clone(portletURL, liferayPortletResponse) %>"
/>

<c:if test='<%= navigation.equals("all-pages") %>'>
	<liferay-frontend:management-bar-sort
		orderByCol="<%= orderByCol %>"
		orderByType="<%= orderByType %>"
		orderColumns="<%= orderColumns %>"
		portletURL="<%= portletURL %>"
	/>
</c:if>