<%--
/**
 * Copyright (c) 2000-present Liferay, Inc. All rights reserved.
 *
 * The contents of this file are subject to the terms of the Liferay Enterprise
 * Subscription License ("License"). You may not use this file except in
 * compliance with the License. You can obtain a copy of the License by
 * contacting Liferay, Inc. See the License for the specific language governing
 * permissions and limitations under the License, including but not limited to
 * distribution rights of the Software.
 *
 *
 *
 */
--%>

<%@ include file="/management_bar_filter/init.jsp" %>

<%
boolean disabled = GetterUtil.getBoolean(request.getAttribute("liferay-frontend:management-bar-filter:disabled"));
String label = (String)request.getAttribute("liferay-frontend:management-bar-filter:label");
List<ManagementBarFilterItem> managementBarFilterItems = (List<ManagementBarFilterItem>)request.getAttribute("liferay-frontend:management-bar-filter:managementBarFilterItems");
String value = (String)request.getAttribute("liferay-frontend:management-bar-filter:value");
%>

<c:if test="<%= managementBarFilterItems.size() > 0 %>">
	<c:choose>
		<c:when test='<%= Validator.isNotNull(label) && label.equals("order-by") %>'>
			<li class="dropdown <%= disabled ? "disabled" : StringPool.BLANK %> management-bar-item-xs-inline-block">
		</c:when>
		<c:otherwise>
			<li class="dropdown <%= disabled ? "disabled" : StringPool.BLANK %>">
		</c:otherwise>
	</c:choose>

	<a aria-expanded="true" class="dropdown-toggle" data-qa-id="filter<%= Validator.isNotNull(label) ? label : StringPool.BLANK %>" data-toggle="<%= disabled ? StringPool.BLANK : "dropdown" %>" href="javascript:;">
		<span class="management-bar-item-title">
			<c:if test="<%= Validator.isNotNull(label) %>">
				<liferay-ui:message key="<%= label %>" />:
			</c:if>

			<liferay-ui:message key="<%= HtmlUtil.escape(value) %>" />
		</span>

		<aui:icon image="caret-double-l" markupView="lexicon" />
	</a>

	<ul class="dropdown-menu" data-qa-id="filter<%= Validator.isNotNull(label) ? label : StringPool.BLANK %>Values">

		<%
		for (ManagementBarFilterItem managementBarFilterItem : managementBarFilterItems) {
		%>

			<li class="<%= managementBarFilterItem.isActive() ? "active" : StringPool.BLANK %>">
				<aui:a href="<%= managementBarFilterItem.getUrl() %>" id="<%= Validator.isNotNull(managementBarFilterItem.getId()) ? managementBarFilterItem.getId() : StringPool.BLANK %>" label="<%= managementBarFilterItem.getLabel() %>" />
			</li>

		<%
		}
		%>

	</ul>
	</li>
</c:if>