/**
 * Copyright (c) 2000-present Liferay, Inc. All rights reserved.
 *
 * The contents of this file are subject to the terms of the Liferay Enterprise
 * Subscription License ("License"). You may not use this file except in
 * compliance with the License. You can obtain a copy of the License by
 * contacting Liferay, Inc. See the License for the specific language governing
 * permissions and limitations under the License, including but not limited to
 * distribution rights of the Software.
 *
 *
 *
 */

package com.liferay.portal.search.configuration;

import aQute.bnd.annotation.ProviderType;
import aQute.bnd.annotation.metatype.Meta;

import com.liferay.portal.configuration.metatype.annotations.ExtendedObjectClassDefinition;

/**
 * @author Michael C. Han
 */
@ExtendedObjectClassDefinition(category = "foundation")
@Meta.OCD(
	id = "com.liferay.portal.search.configuration.IndexerRegistryConfiguration",
	localization = "content/Language",
	name = "indexer.registry.configuration.name"
)
@ProviderType
public interface IndexerRegistryConfiguration {

	@Meta.AD(deflt = "true", required = false)
	public boolean buffered();

	@Meta.AD(deflt = "DEFAULT", required = false)
	public String bufferedExecutionMode();

	@Meta.AD(deflt = "200", required = false)
	public int maxBufferSize();

	@Meta.AD(deflt = "0.90", max = "0.99", min = "0.1", required = false)
	public float minimumBufferAvailabilityPercentage();

}