/**
 * Copyright (c) 2000-present Liferay, Inc. All rights reserved.
 *
 * The contents of this file are subject to the terms of the Liferay Enterprise
 * Subscription License ("License"). You may not use this file except in
 * compliance with the License. You can obtain a copy of the License by
 * contacting Liferay, Inc. See the License for the specific language governing
 * permissions and limitations under the License, including but not limited to
 * distribution rights of the Software.
 *
 *
 *
 */

package com.liferay.portal.template.velocity.configuration;

import aQute.bnd.annotation.metatype.Meta;

import com.liferay.portal.configuration.metatype.annotations.ExtendedObjectClassDefinition;

/**
 * @author Peter Fellwock
 */
@ExtendedObjectClassDefinition(category = "foundation")
@Meta.OCD(
	id = "com.liferay.portal.template.velocity.configuration.VelocityEngineConfiguration",
	localization = "content/Language",
	name = "velocity.engine.configuration.name"
)
public interface VelocityEngineConfiguration {

	@Meta.AD(deflt = "false", required = false)
	public boolean directiveIfToStringNullCheck();

	@Meta.AD(deflt = "60", required = false)
	public int resourceModificationCheckInterval();

	@Meta.AD(
		deflt = "com.liferay.portal.json.jabsorb.serializer.LiferayJSONDeserializationWhitelist|java.lang.Class|java.lang.ClassLoader|java.lang.Compiler|java.lang.Package|java.lang.Process|java.lang.Runtime|java.lang.RuntimePermission|java.lang.SecurityManager|java.lang.System|java.lang.Thread|java.lang.ThreadGroup|java.lang.ThreadLocal",
		required = false
	)
	public String[] restrictedClasses();

	@Meta.AD(
		deflt = "com.liferay.portal.model.impl.CompanyImpl#getKey",
		name = "restricted-methods", required = false
	)
	public String[] restrictedMethods();

	@Meta.AD(
		deflt = "com.liferay.portal.spring.context | com.ibm | io.undertow | java.lang.reflect | org.apache | org.glassfish | org.jboss | org.springframework | org.wildfly | weblogic",
		name = "restricted-packages", required = false
	)
	public String[] restrictedPackages();

	@Meta.AD(
		deflt = "httpUtilUnsafe|serviceLocator|staticFieldGetter|utilLocator",
		name = "restricted-variables", required = false
	)
	public String[] restrictedVariables();

	@Meta.AD(deflt = "VM_global_library.vm|VM_liferay.vm", required = false)
	public String[] velocimacroLibrary();

	@Meta.AD(
		deflt = "org.apache.velocity.runtime.log.SimpleLog4JLogSystem",
		required = false
	)
	public String logger();

	@Meta.AD(deflt = "org.apache.velocity", required = false)
	public String loggerCategory();

}