/**
 * Copyright (c) 2000-present Liferay, Inc. All rights reserved.
 *
 * The contents of this file are subject to the terms of the Liferay Enterprise
 * Subscription License ("License"). You may not use this file except in
 * compliance with the License. You can obtain a copy of the License by
 * contacting Liferay, Inc. See the License for the specific language governing
 * permissions and limitations under the License, including but not limited to
 * distribution rights of the Software.
 *
 *
 *
 */

package com.liferay.message.boards.kernel.service;

import aQute.bnd.annotation.ProviderType;

import com.liferay.portal.kernel.bean.PortalBeanLocatorUtil;
import com.liferay.portal.kernel.util.ReferenceRegistry;

/**
 * Provides the local service utility for MBMessage. This utility wraps
 * {@link com.liferay.portlet.messageboards.service.impl.MBMessageLocalServiceImpl} and is the
 * primary access point for service operations in application layer code running
 * on the local server. Methods of this service will not have security checks
 * based on the propagated JAAS credentials because this service can only be
 * accessed from within the same VM.
 *
 * @author Brian Wing Shun Chan
 * @see MBMessageLocalService
 * @see com.liferay.portlet.messageboards.service.base.MBMessageLocalServiceBaseImpl
 * @see com.liferay.portlet.messageboards.service.impl.MBMessageLocalServiceImpl
 * @generated
 */
@ProviderType
public class MBMessageLocalServiceUtil {
	/*
	 * NOTE FOR DEVELOPERS:
	 *
	 * Never modify this class directly. Add custom service methods to {@link com.liferay.portlet.messageboards.service.impl.MBMessageLocalServiceImpl} and rerun ServiceBuilder to regenerate this class.
	 */
	public static com.liferay.message.boards.kernel.model.MBMessage addDiscussionMessage(
		long userId, java.lang.String userName, long groupId,
		java.lang.String className, long classPK, int workflowAction)
		throws com.liferay.portal.kernel.exception.PortalException {
		return getService()
				   .addDiscussionMessage(userId, userName, groupId, className,
			classPK, workflowAction);
	}

	public static com.liferay.message.boards.kernel.model.MBMessage addDiscussionMessage(
		long userId, java.lang.String userName, long groupId,
		java.lang.String className, long classPK, long threadId,
		long parentMessageId, java.lang.String subject, java.lang.String body,
		com.liferay.portal.kernel.service.ServiceContext serviceContext)
		throws com.liferay.portal.kernel.exception.PortalException {
		return getService()
				   .addDiscussionMessage(userId, userName, groupId, className,
			classPK, threadId, parentMessageId, subject, body, serviceContext);
	}

	/**
	* Adds the message-boards message to the database. Also notifies the appropriate model listeners.
	*
	* @param mbMessage the message-boards message
	* @return the message-boards message that was added
	*/
	public static com.liferay.message.boards.kernel.model.MBMessage addMBMessage(
		com.liferay.message.boards.kernel.model.MBMessage mbMessage) {
		return getService().addMBMessage(mbMessage);
	}

	/**
	* @deprecated As of 7.0.0, replaced by {@link #addMessage(long, String,
	long, long, String, String, ServiceContext)}
	*/
	@Deprecated
	public static com.liferay.message.boards.kernel.model.MBMessage addMessage(
		long userId, java.lang.String userName, long categoryId,
		java.lang.String subject, java.lang.String body,
		com.liferay.portal.kernel.service.ServiceContext serviceContext)
		throws com.liferay.portal.kernel.exception.PortalException {
		return getService()
				   .addMessage(userId, userName, categoryId, subject, body,
			serviceContext);
	}

	public static com.liferay.message.boards.kernel.model.MBMessage addMessage(
		long userId, java.lang.String userName, long groupId, long categoryId,
		java.lang.String subject, java.lang.String body,
		com.liferay.portal.kernel.service.ServiceContext serviceContext)
		throws com.liferay.portal.kernel.exception.PortalException {
		return getService()
				   .addMessage(userId, userName, groupId, categoryId, subject,
			body, serviceContext);
	}

	public static com.liferay.message.boards.kernel.model.MBMessage addMessage(
		long userId, java.lang.String userName, long groupId, long categoryId,
		java.lang.String subject, java.lang.String body,
		java.lang.String format, java.lang.String fileName, java.io.File file,
		boolean anonymous, double priority, boolean allowPingbacks,
		com.liferay.portal.kernel.service.ServiceContext serviceContext)
		throws com.liferay.portal.kernel.exception.PortalException,
			java.io.FileNotFoundException {
		return getService()
				   .addMessage(userId, userName, groupId, categoryId, subject,
			body, format, fileName, file, anonymous, priority, allowPingbacks,
			serviceContext);
	}

	public static com.liferay.message.boards.kernel.model.MBMessage addMessage(
		long userId, java.lang.String userName, long groupId, long categoryId,
		java.lang.String subject, java.lang.String body,
		java.lang.String format,
		java.util.List<com.liferay.portal.kernel.util.ObjectValuePair<java.lang.String, java.io.InputStream>> inputStreamOVPs,
		boolean anonymous, double priority, boolean allowPingbacks,
		com.liferay.portal.kernel.service.ServiceContext serviceContext)
		throws com.liferay.portal.kernel.exception.PortalException {
		return getService()
				   .addMessage(userId, userName, groupId, categoryId, subject,
			body, format, inputStreamOVPs, anonymous, priority, allowPingbacks,
			serviceContext);
	}

	public static com.liferay.message.boards.kernel.model.MBMessage addMessage(
		long userId, java.lang.String userName, long groupId, long categoryId,
		long threadId, long parentMessageId, java.lang.String subject,
		java.lang.String body, java.lang.String format,
		java.util.List<com.liferay.portal.kernel.util.ObjectValuePair<java.lang.String, java.io.InputStream>> inputStreamOVPs,
		boolean anonymous, double priority, boolean allowPingbacks,
		com.liferay.portal.kernel.service.ServiceContext serviceContext)
		throws com.liferay.portal.kernel.exception.PortalException {
		return getService()
				   .addMessage(userId, userName, groupId, categoryId, threadId,
			parentMessageId, subject, body, format, inputStreamOVPs, anonymous,
			priority, allowPingbacks, serviceContext);
	}

	/**
	* Creates a new message-boards message with the primary key. Does not add the message-boards message to the database.
	*
	* @param messageId the primary key for the new message-boards message
	* @return the new message-boards message
	*/
	public static com.liferay.message.boards.kernel.model.MBMessage createMBMessage(
		long messageId) {
		return getService().createMBMessage(messageId);
	}

	public static com.liferay.message.boards.kernel.model.MBMessage deleteDiscussionMessage(
		long messageId)
		throws com.liferay.portal.kernel.exception.PortalException {
		return getService().deleteDiscussionMessage(messageId);
	}

	/**
	* Deletes the message-boards message from the database. Also notifies the appropriate model listeners.
	*
	* @param mbMessage the message-boards message
	* @return the message-boards message that was removed
	*/
	public static com.liferay.message.boards.kernel.model.MBMessage deleteMBMessage(
		com.liferay.message.boards.kernel.model.MBMessage mbMessage) {
		return getService().deleteMBMessage(mbMessage);
	}

	/**
	* Deletes the message-boards message with the primary key from the database. Also notifies the appropriate model listeners.
	*
	* @param messageId the primary key of the message-boards message
	* @return the message-boards message that was removed
	* @throws PortalException if a message-boards message with the primary key could not be found
	*/
	public static com.liferay.message.boards.kernel.model.MBMessage deleteMBMessage(
		long messageId)
		throws com.liferay.portal.kernel.exception.PortalException {
		return getService().deleteMBMessage(messageId);
	}

	public static com.liferay.message.boards.kernel.model.MBMessage deleteMessage(
		com.liferay.message.boards.kernel.model.MBMessage message)
		throws com.liferay.portal.kernel.exception.PortalException {
		return getService().deleteMessage(message);
	}

	public static com.liferay.message.boards.kernel.model.MBMessage deleteMessage(
		long messageId)
		throws com.liferay.portal.kernel.exception.PortalException {
		return getService().deleteMessage(messageId);
	}

	public static com.liferay.message.boards.kernel.model.MBMessage fetchMBMessage(
		long messageId) {
		return getService().fetchMBMessage(messageId);
	}

	/**
	* Returns the message-boards message matching the UUID and group.
	*
	* @param uuid the message-boards message's UUID
	* @param groupId the primary key of the group
	* @return the matching message-boards message, or <code>null</code> if a matching message-boards message could not be found
	*/
	public static com.liferay.message.boards.kernel.model.MBMessage fetchMBMessageByUuidAndGroupId(
		java.lang.String uuid, long groupId) {
		return getService().fetchMBMessageByUuidAndGroupId(uuid, groupId);
	}

	/**
	* Returns the message-boards message with the primary key.
	*
	* @param messageId the primary key of the message-boards message
	* @return the message-boards message
	* @throws PortalException if a message-boards message with the primary key could not be found
	*/
	public static com.liferay.message.boards.kernel.model.MBMessage getMBMessage(
		long messageId)
		throws com.liferay.portal.kernel.exception.PortalException {
		return getService().getMBMessage(messageId);
	}

	/**
	* Returns the message-boards message matching the UUID and group.
	*
	* @param uuid the message-boards message's UUID
	* @param groupId the primary key of the group
	* @return the matching message-boards message
	* @throws PortalException if a matching message-boards message could not be found
	*/
	public static com.liferay.message.boards.kernel.model.MBMessage getMBMessageByUuidAndGroupId(
		java.lang.String uuid, long groupId)
		throws com.liferay.portal.kernel.exception.PortalException {
		return getService().getMBMessageByUuidAndGroupId(uuid, groupId);
	}

	public static com.liferay.message.boards.kernel.model.MBMessage getMessage(
		long messageId)
		throws com.liferay.portal.kernel.exception.PortalException {
		return getService().getMessage(messageId);
	}

	public static com.liferay.message.boards.kernel.model.MBMessage updateDiscussionMessage(
		long userId, long messageId, java.lang.String className, long classPK,
		java.lang.String subject, java.lang.String body,
		com.liferay.portal.kernel.service.ServiceContext serviceContext)
		throws com.liferay.portal.kernel.exception.PortalException {
		return getService()
				   .updateDiscussionMessage(userId, messageId, className,
			classPK, subject, body, serviceContext);
	}

	/**
	* Updates the message-boards message in the database or adds it if it does not yet exist. Also notifies the appropriate model listeners.
	*
	* @param mbMessage the message-boards message
	* @return the message-boards message that was updated
	*/
	public static com.liferay.message.boards.kernel.model.MBMessage updateMBMessage(
		com.liferay.message.boards.kernel.model.MBMessage mbMessage) {
		return getService().updateMBMessage(mbMessage);
	}

	/**
	* @deprecated As of 7.0.0, with no direct replacement
	*/
	@Deprecated
	public static com.liferay.message.boards.kernel.model.MBMessage updateMessage(
		long messageId, java.lang.String body)
		throws com.liferay.portal.kernel.exception.PortalException {
		return getService().updateMessage(messageId, body);
	}

	public static com.liferay.message.boards.kernel.model.MBMessage updateMessage(
		long userId, long messageId, java.lang.String body,
		com.liferay.portal.kernel.service.ServiceContext serviceContext)
		throws com.liferay.portal.kernel.exception.PortalException {
		return getService()
				   .updateMessage(userId, messageId, body, serviceContext);
	}

	public static com.liferay.message.boards.kernel.model.MBMessage updateMessage(
		long userId, long messageId, java.lang.String subject,
		java.lang.String body,
		java.util.List<com.liferay.portal.kernel.util.ObjectValuePair<java.lang.String, java.io.InputStream>> inputStreamOVPs,
		java.util.List<java.lang.String> existingFiles, double priority,
		boolean allowPingbacks,
		com.liferay.portal.kernel.service.ServiceContext serviceContext)
		throws com.liferay.portal.kernel.exception.PortalException {
		return getService()
				   .updateMessage(userId, messageId, subject, body,
			inputStreamOVPs, existingFiles, priority, allowPingbacks,
			serviceContext);
	}

	/**
	* @deprecated As of 7.0.0, replaced by {@link #updateStatus(long, long,
	int, ServiceContext, Map)}
	*/
	@Deprecated
	public static com.liferay.message.boards.kernel.model.MBMessage updateStatus(
		long userId, long messageId, int status,
		com.liferay.portal.kernel.service.ServiceContext serviceContext)
		throws com.liferay.portal.kernel.exception.PortalException {
		return getService()
				   .updateStatus(userId, messageId, status, serviceContext);
	}

	public static com.liferay.message.boards.kernel.model.MBMessage updateStatus(
		long userId, long messageId, int status,
		com.liferay.portal.kernel.service.ServiceContext serviceContext,
		java.util.Map<java.lang.String, java.io.Serializable> workflowContext)
		throws com.liferay.portal.kernel.exception.PortalException {
		return getService()
				   .updateStatus(userId, messageId, status, serviceContext,
			workflowContext);
	}

	public static com.liferay.message.boards.kernel.model.MBMessageDisplay getDiscussionMessageDisplay(
		long userId, long groupId, java.lang.String className, long classPK,
		int status) throws com.liferay.portal.kernel.exception.PortalException {
		return getService()
				   .getDiscussionMessageDisplay(userId, groupId, className,
			classPK, status);
	}

	/**
	* @deprecated As of 7.0.0, replaced by {@link
	#getDiscussionMessageDisplay(long, long, String, long, int)}
	*/
	@Deprecated
	public static com.liferay.message.boards.kernel.model.MBMessageDisplay getDiscussionMessageDisplay(
		long userId, long groupId, java.lang.String className, long classPK,
		int status, java.lang.String threadView)
		throws com.liferay.portal.kernel.exception.PortalException {
		return getService()
				   .getDiscussionMessageDisplay(userId, groupId, className,
			classPK, status, threadView);
	}

	public static com.liferay.message.boards.kernel.model.MBMessageDisplay getDiscussionMessageDisplay(
		long userId, long groupId, java.lang.String className, long classPK,
		int status,
		java.util.Comparator<com.liferay.message.boards.kernel.model.MBMessage> comparator)
		throws com.liferay.portal.kernel.exception.PortalException {
		return getService()
				   .getDiscussionMessageDisplay(userId, groupId, className,
			classPK, status, comparator);
	}

	public static com.liferay.message.boards.kernel.model.MBMessageDisplay getMessageDisplay(
		long userId, com.liferay.message.boards.kernel.model.MBMessage message,
		int status) throws com.liferay.portal.kernel.exception.PortalException {
		return getService().getMessageDisplay(userId, message, status);
	}

	/**
	* @deprecated As of 7.0.0, replaced by {@link #getMessageDisplay(long,
	MBMessage, int)}
	*/
	@Deprecated
	public static com.liferay.message.boards.kernel.model.MBMessageDisplay getMessageDisplay(
		long userId, com.liferay.message.boards.kernel.model.MBMessage message,
		int status, java.lang.String threadView, boolean includePrevAndNext)
		throws com.liferay.portal.kernel.exception.PortalException {
		return getService()
				   .getMessageDisplay(userId, message, status, threadView,
			includePrevAndNext);
	}

	/**
	* @deprecated As of 7.0.0, replaced by {@link #getMessageDisplay(long,
	MBMessage, int, Comparator)} (
	*/
	@Deprecated
	public static com.liferay.message.boards.kernel.model.MBMessageDisplay getMessageDisplay(
		long userId, com.liferay.message.boards.kernel.model.MBMessage message,
		int status, java.lang.String threadView, boolean includePrevAndNext,
		java.util.Comparator<com.liferay.message.boards.kernel.model.MBMessage> comparator)
		throws com.liferay.portal.kernel.exception.PortalException {
		return getService()
				   .getMessageDisplay(userId, message, status, threadView,
			includePrevAndNext, comparator);
	}

	public static com.liferay.message.boards.kernel.model.MBMessageDisplay getMessageDisplay(
		long userId, com.liferay.message.boards.kernel.model.MBMessage message,
		int status,
		java.util.Comparator<com.liferay.message.boards.kernel.model.MBMessage> comparator)
		throws com.liferay.portal.kernel.exception.PortalException {
		return getService()
				   .getMessageDisplay(userId, message, status, comparator);
	}

	public static com.liferay.message.boards.kernel.model.MBMessageDisplay getMessageDisplay(
		long userId, long messageId, int status)
		throws com.liferay.portal.kernel.exception.PortalException {
		return getService().getMessageDisplay(userId, messageId, status);
	}

	/**
	* @deprecated As of 7.0.0, replaced by {@link #getMessageDisplay(long,
	long, int)}
	*/
	@Deprecated
	public static com.liferay.message.boards.kernel.model.MBMessageDisplay getMessageDisplay(
		long userId, long messageId, int status, java.lang.String threadView,
		boolean includePrevAndNext)
		throws com.liferay.portal.kernel.exception.PortalException {
		return getService()
				   .getMessageDisplay(userId, messageId, status, threadView,
			includePrevAndNext);
	}

	public static com.liferay.portal.kernel.dao.orm.ActionableDynamicQuery getActionableDynamicQuery() {
		return getService().getActionableDynamicQuery();
	}

	public static com.liferay.portal.kernel.dao.orm.DynamicQuery dynamicQuery() {
		return getService().dynamicQuery();
	}

	public static com.liferay.portal.kernel.dao.orm.ExportActionableDynamicQuery getExportActionableDynamicQuery(
		com.liferay.exportimport.kernel.lar.PortletDataContext portletDataContext) {
		return getService().getExportActionableDynamicQuery(portletDataContext);
	}

	public static com.liferay.portal.kernel.dao.orm.IndexableActionableDynamicQuery getIndexableActionableDynamicQuery() {
		return getService().getIndexableActionableDynamicQuery();
	}

	/**
	* @throws PortalException
	*/
	public static com.liferay.portal.kernel.model.PersistedModel deletePersistedModel(
		com.liferay.portal.kernel.model.PersistedModel persistedModel)
		throws com.liferay.portal.kernel.exception.PortalException {
		return getService().deletePersistedModel(persistedModel);
	}

	public static com.liferay.portal.kernel.model.PersistedModel getPersistedModel(
		java.io.Serializable primaryKeyObj)
		throws com.liferay.portal.kernel.exception.PortalException {
		return getService().getPersistedModel(primaryKeyObj);
	}

	public static int getCategoryMessagesCount(long groupId, long categoryId,
		int status) {
		return getService().getCategoryMessagesCount(groupId, categoryId, status);
	}

	public static int getCompanyMessagesCount(long companyId, int status) {
		return getService().getCompanyMessagesCount(companyId, status);
	}

	public static int getDiscussionMessagesCount(java.lang.String className,
		long classPK, int status) {
		return getService()
				   .getDiscussionMessagesCount(className, classPK, status);
	}

	public static int getDiscussionMessagesCount(long classNameId,
		long classPK, int status) {
		return getService()
				   .getDiscussionMessagesCount(classNameId, classPK, status);
	}

	public static int getGroupMessagesCount(long groupId, int status) {
		return getService().getGroupMessagesCount(groupId, status);
	}

	public static int getGroupMessagesCount(long groupId, long userId,
		int status) {
		return getService().getGroupMessagesCount(groupId, userId, status);
	}

	/**
	* Returns the number of message-boards messages.
	*
	* @return the number of message-boards messages
	*/
	public static int getMBMessagesCount() {
		return getService().getMBMessagesCount();
	}

	public static int getPositionInThread(long messageId)
		throws com.liferay.portal.kernel.exception.PortalException {
		return getService().getPositionInThread(messageId);
	}

	public static int getThreadMessagesCount(long threadId, int status) {
		return getService().getThreadMessagesCount(threadId, status);
	}

	public static int getUserDiscussionMessagesCount(long userId,
		java.lang.String className, long classPK, int status) {
		return getService()
				   .getUserDiscussionMessagesCount(userId, className, classPK,
			status);
	}

	public static int getUserDiscussionMessagesCount(long userId,
		long classNameId, long classPK, int status) {
		return getService()
				   .getUserDiscussionMessagesCount(userId, classNameId,
			classPK, status);
	}

	public static int getUserDiscussionMessagesCount(long userId,
		long[] classNameIds, int status) {
		return getService()
				   .getUserDiscussionMessagesCount(userId, classNameIds, status);
	}

	/**
	* Returns the OSGi service identifier.
	*
	* @return the OSGi service identifier
	*/
	public static java.lang.String getOSGiServiceIdentifier() {
		return getService().getOSGiServiceIdentifier();
	}

	/**
	* Performs a dynamic query on the database and returns the matching rows.
	*
	* @param dynamicQuery the dynamic query
	* @return the matching rows
	*/
	public static <T> java.util.List<T> dynamicQuery(
		com.liferay.portal.kernel.dao.orm.DynamicQuery dynamicQuery) {
		return getService().dynamicQuery(dynamicQuery);
	}

	/**
	* Performs a dynamic query on the database and returns a range of the matching rows.
	*
	* <p>
	* Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set. If <code>orderByComparator</code> is specified, then the query will include the given ORDER BY logic. If <code>orderByComparator</code> is absent and pagination is required (<code>start</code> and <code>end</code> are not {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS}), then the query will include the default ORDER BY logic from {@link com.liferay.portlet.messageboards.model.impl.MBMessageModelImpl}. If both <code>orderByComparator</code> and pagination are absent, for performance reasons, the query will not have an ORDER BY clause and the returned result set will be sorted on by the primary key in an ascending order.
	* </p>
	*
	* @param dynamicQuery the dynamic query
	* @param start the lower bound of the range of model instances
	* @param end the upper bound of the range of model instances (not inclusive)
	* @return the range of matching rows
	*/
	public static <T> java.util.List<T> dynamicQuery(
		com.liferay.portal.kernel.dao.orm.DynamicQuery dynamicQuery, int start,
		int end) {
		return getService().dynamicQuery(dynamicQuery, start, end);
	}

	/**
	* Performs a dynamic query on the database and returns an ordered range of the matching rows.
	*
	* <p>
	* Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set. If <code>orderByComparator</code> is specified, then the query will include the given ORDER BY logic. If <code>orderByComparator</code> is absent and pagination is required (<code>start</code> and <code>end</code> are not {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS}), then the query will include the default ORDER BY logic from {@link com.liferay.portlet.messageboards.model.impl.MBMessageModelImpl}. If both <code>orderByComparator</code> and pagination are absent, for performance reasons, the query will not have an ORDER BY clause and the returned result set will be sorted on by the primary key in an ascending order.
	* </p>
	*
	* @param dynamicQuery the dynamic query
	* @param start the lower bound of the range of model instances
	* @param end the upper bound of the range of model instances (not inclusive)
	* @param orderByComparator the comparator to order the results by (optionally <code>null</code>)
	* @return the ordered range of matching rows
	*/
	public static <T> java.util.List<T> dynamicQuery(
		com.liferay.portal.kernel.dao.orm.DynamicQuery dynamicQuery, int start,
		int end,
		com.liferay.portal.kernel.util.OrderByComparator<T> orderByComparator) {
		return getService()
				   .dynamicQuery(dynamicQuery, start, end, orderByComparator);
	}

	public static java.util.List<com.liferay.message.boards.kernel.model.MBMessage> getCategoryMessages(
		long groupId, long categoryId, int status, int start, int end) {
		return getService()
				   .getCategoryMessages(groupId, categoryId, status, start, end);
	}

	public static java.util.List<com.liferay.message.boards.kernel.model.MBMessage> getCategoryMessages(
		long groupId, long categoryId, int status, int start, int end,
		com.liferay.portal.kernel.util.OrderByComparator<com.liferay.message.boards.kernel.model.MBMessage> obc) {
		return getService()
				   .getCategoryMessages(groupId, categoryId, status, start,
			end, obc);
	}

	public static java.util.List<com.liferay.message.boards.kernel.model.MBMessage> getCompanyMessages(
		long companyId, int status, int start, int end) {
		return getService().getCompanyMessages(companyId, status, start, end);
	}

	public static java.util.List<com.liferay.message.boards.kernel.model.MBMessage> getCompanyMessages(
		long companyId, int status, int start, int end,
		com.liferay.portal.kernel.util.OrderByComparator<com.liferay.message.boards.kernel.model.MBMessage> obc) {
		return getService()
				   .getCompanyMessages(companyId, status, start, end, obc);
	}

	public static java.util.List<com.liferay.message.boards.kernel.model.MBDiscussion> getDiscussions(
		java.lang.String className) {
		return getService().getDiscussions(className);
	}

	public static java.util.List<com.liferay.message.boards.kernel.model.MBMessage> getGroupMessages(
		long groupId, int status, int start, int end) {
		return getService().getGroupMessages(groupId, status, start, end);
	}

	public static java.util.List<com.liferay.message.boards.kernel.model.MBMessage> getGroupMessages(
		long groupId, int status, int start, int end,
		com.liferay.portal.kernel.util.OrderByComparator<com.liferay.message.boards.kernel.model.MBMessage> obc) {
		return getService().getGroupMessages(groupId, status, start, end, obc);
	}

	public static java.util.List<com.liferay.message.boards.kernel.model.MBMessage> getGroupMessages(
		long groupId, long userId, int status, int start, int end) {
		return getService().getGroupMessages(groupId, userId, status, start, end);
	}

	public static java.util.List<com.liferay.message.boards.kernel.model.MBMessage> getGroupMessages(
		long groupId, long userId, int status, int start, int end,
		com.liferay.portal.kernel.util.OrderByComparator<com.liferay.message.boards.kernel.model.MBMessage> obc) {
		return getService()
				   .getGroupMessages(groupId, userId, status, start, end, obc);
	}

	/**
	* Returns a range of all the message-boards messages.
	*
	* <p>
	* Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set. If <code>orderByComparator</code> is specified, then the query will include the given ORDER BY logic. If <code>orderByComparator</code> is absent and pagination is required (<code>start</code> and <code>end</code> are not {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS}), then the query will include the default ORDER BY logic from {@link com.liferay.portlet.messageboards.model.impl.MBMessageModelImpl}. If both <code>orderByComparator</code> and pagination are absent, for performance reasons, the query will not have an ORDER BY clause and the returned result set will be sorted on by the primary key in an ascending order.
	* </p>
	*
	* @param start the lower bound of the range of message-boards messages
	* @param end the upper bound of the range of message-boards messages (not inclusive)
	* @return the range of message-boards messages
	*/
	public static java.util.List<com.liferay.message.boards.kernel.model.MBMessage> getMBMessages(
		int start, int end) {
		return getService().getMBMessages(start, end);
	}

	/**
	* Returns all the message-boards messages matching the UUID and company.
	*
	* @param uuid the UUID of the message-boards messages
	* @param companyId the primary key of the company
	* @return the matching message-boards messages, or an empty list if no matches were found
	*/
	public static java.util.List<com.liferay.message.boards.kernel.model.MBMessage> getMBMessagesByUuidAndCompanyId(
		java.lang.String uuid, long companyId) {
		return getService().getMBMessagesByUuidAndCompanyId(uuid, companyId);
	}

	/**
	* Returns a range of message-boards messages matching the UUID and company.
	*
	* @param uuid the UUID of the message-boards messages
	* @param companyId the primary key of the company
	* @param start the lower bound of the range of message-boards messages
	* @param end the upper bound of the range of message-boards messages (not inclusive)
	* @param orderByComparator the comparator to order the results by (optionally <code>null</code>)
	* @return the range of matching message-boards messages, or an empty list if no matches were found
	*/
	public static java.util.List<com.liferay.message.boards.kernel.model.MBMessage> getMBMessagesByUuidAndCompanyId(
		java.lang.String uuid, long companyId, int start, int end,
		com.liferay.portal.kernel.util.OrderByComparator<com.liferay.message.boards.kernel.model.MBMessage> orderByComparator) {
		return getService()
				   .getMBMessagesByUuidAndCompanyId(uuid, companyId, start,
			end, orderByComparator);
	}

	public static java.util.List<com.liferay.message.boards.kernel.model.MBMessage> getMessages(
		java.lang.String className, long classPK, int status) {
		return getService().getMessages(className, classPK, status);
	}

	public static java.util.List<com.liferay.message.boards.kernel.model.MBMessage> getNoAssetMessages() {
		return getService().getNoAssetMessages();
	}

	public static java.util.List<com.liferay.message.boards.kernel.model.MBMessage> getThreadMessages(
		long threadId, int status) {
		return getService().getThreadMessages(threadId, status);
	}

	public static java.util.List<com.liferay.message.boards.kernel.model.MBMessage> getThreadMessages(
		long threadId, int status, int start, int end) {
		return getService().getThreadMessages(threadId, status, start, end);
	}

	public static java.util.List<com.liferay.message.boards.kernel.model.MBMessage> getThreadMessages(
		long threadId, int status,
		java.util.Comparator<com.liferay.message.boards.kernel.model.MBMessage> comparator) {
		return getService().getThreadMessages(threadId, status, comparator);
	}

	public static java.util.List<com.liferay.message.boards.kernel.model.MBMessage> getThreadMessages(
		long userId, long threadId, int status, int start, int end,
		java.util.Comparator<com.liferay.message.boards.kernel.model.MBMessage> comparator) {
		return getService()
				   .getThreadMessages(userId, threadId, status, start, end,
			comparator);
	}

	public static java.util.List<com.liferay.message.boards.kernel.model.MBMessage> getThreadRepliesMessages(
		long threadId, int status, int start, int end) {
		return getService()
				   .getThreadRepliesMessages(threadId, status, start, end);
	}

	public static java.util.List<com.liferay.message.boards.kernel.model.MBMessage> getUserDiscussionMessages(
		long userId, java.lang.String className, long classPK, int status,
		int start, int end,
		com.liferay.portal.kernel.util.OrderByComparator<com.liferay.message.boards.kernel.model.MBMessage> obc) {
		return getService()
				   .getUserDiscussionMessages(userId, className, classPK,
			status, start, end, obc);
	}

	public static java.util.List<com.liferay.message.boards.kernel.model.MBMessage> getUserDiscussionMessages(
		long userId, long classNameId, long classPK, int status, int start,
		int end,
		com.liferay.portal.kernel.util.OrderByComparator<com.liferay.message.boards.kernel.model.MBMessage> obc) {
		return getService()
				   .getUserDiscussionMessages(userId, classNameId, classPK,
			status, start, end, obc);
	}

	public static java.util.List<com.liferay.message.boards.kernel.model.MBMessage> getUserDiscussionMessages(
		long userId, long[] classNameIds, int status, int start, int end,
		com.liferay.portal.kernel.util.OrderByComparator<com.liferay.message.boards.kernel.model.MBMessage> obc) {
		return getService()
				   .getUserDiscussionMessages(userId, classNameIds, status,
			start, end, obc);
	}

	/**
	* Returns the number of rows matching the dynamic query.
	*
	* @param dynamicQuery the dynamic query
	* @return the number of rows matching the dynamic query
	*/
	public static long dynamicQueryCount(
		com.liferay.portal.kernel.dao.orm.DynamicQuery dynamicQuery) {
		return getService().dynamicQueryCount(dynamicQuery);
	}

	/**
	* Returns the number of rows matching the dynamic query.
	*
	* @param dynamicQuery the dynamic query
	* @param projection the projection to apply to the query
	* @return the number of rows matching the dynamic query
	*/
	public static long dynamicQueryCount(
		com.liferay.portal.kernel.dao.orm.DynamicQuery dynamicQuery,
		com.liferay.portal.kernel.dao.orm.Projection projection) {
		return getService().dynamicQueryCount(dynamicQuery, projection);
	}

	public static long moveMessageAttachmentToTrash(long userId,
		long messageId, java.lang.String fileName)
		throws com.liferay.portal.kernel.exception.PortalException {
		return getService()
				   .moveMessageAttachmentToTrash(userId, messageId, fileName);
	}

	public static void addMessageAttachment(long userId, long messageId,
		java.lang.String fileName, java.io.File file, java.lang.String mimeType)
		throws com.liferay.portal.kernel.exception.PortalException {
		getService()
			.addMessageAttachment(userId, messageId, fileName, file, mimeType);
	}

	public static void addMessageResources(
		com.liferay.message.boards.kernel.model.MBMessage message,
		boolean addGroupPermissions, boolean addGuestPermissions)
		throws com.liferay.portal.kernel.exception.PortalException {
		getService()
			.addMessageResources(message, addGroupPermissions,
			addGuestPermissions);
	}

	public static void addMessageResources(
		com.liferay.message.boards.kernel.model.MBMessage message,
		com.liferay.portal.kernel.service.permission.ModelPermissions modelPermissions)
		throws com.liferay.portal.kernel.exception.PortalException {
		getService().addMessageResources(message, modelPermissions);
	}

	public static void addMessageResources(long messageId,
		boolean addGroupPermissions, boolean addGuestPermissions)
		throws com.liferay.portal.kernel.exception.PortalException {
		getService()
			.addMessageResources(messageId, addGroupPermissions,
			addGuestPermissions);
	}

	public static void addMessageResources(long messageId,
		com.liferay.portal.kernel.service.permission.ModelPermissions modelPermissions)
		throws com.liferay.portal.kernel.exception.PortalException {
		getService().addMessageResources(messageId, modelPermissions);
	}

	public static void deleteDiscussionMessages(java.lang.String className,
		long classPK)
		throws com.liferay.portal.kernel.exception.PortalException {
		getService().deleteDiscussionMessages(className, classPK);
	}

	public static void deleteMessageAttachment(long messageId,
		java.lang.String fileName)
		throws com.liferay.portal.kernel.exception.PortalException {
		getService().deleteMessageAttachment(messageId, fileName);
	}

	public static void deleteMessageAttachments(long messageId)
		throws com.liferay.portal.kernel.exception.PortalException {
		getService().deleteMessageAttachments(messageId);
	}

	public static void emptyMessageAttachments(long messageId)
		throws com.liferay.portal.kernel.exception.PortalException {
		getService().emptyMessageAttachments(messageId);
	}

	public static void restoreMessageAttachmentFromTrash(long userId,
		long messageId, java.lang.String deletedFileName)
		throws com.liferay.portal.kernel.exception.PortalException {
		getService()
			.restoreMessageAttachmentFromTrash(userId, messageId,
			deletedFileName);
	}

	public static void subscribeMessage(long userId, long messageId)
		throws com.liferay.portal.kernel.exception.PortalException {
		getService().subscribeMessage(userId, messageId);
	}

	public static void unsubscribeMessage(long userId, long messageId)
		throws com.liferay.portal.kernel.exception.PortalException {
		getService().unsubscribeMessage(userId, messageId);
	}

	public static void updateAnswer(
		com.liferay.message.boards.kernel.model.MBMessage message,
		boolean answer, boolean cascade)
		throws com.liferay.portal.kernel.exception.PortalException {
		getService().updateAnswer(message, answer, cascade);
	}

	public static void updateAnswer(long messageId, boolean answer,
		boolean cascade)
		throws com.liferay.portal.kernel.exception.PortalException {
		getService().updateAnswer(messageId, answer, cascade);
	}

	public static void updateAsset(long userId,
		com.liferay.message.boards.kernel.model.MBMessage message,
		long[] assetCategoryIds, java.lang.String[] assetTagNames,
		long[] assetLinkEntryIds)
		throws com.liferay.portal.kernel.exception.PortalException {
		getService()
			.updateAsset(userId, message, assetCategoryIds, assetTagNames,
			assetLinkEntryIds);
	}

	public static void updateUserName(long userId, java.lang.String userName) {
		getService().updateUserName(userId, userName);
	}

	public static MBMessageLocalService getService() {
		if (_service == null) {
			_service = (MBMessageLocalService)PortalBeanLocatorUtil.locate(MBMessageLocalService.class.getName());

			ReferenceRegistry.registerReference(MBMessageLocalServiceUtil.class,
				"_service");
		}

		return _service;
	}

	private static MBMessageLocalService _service;
}