/**
 * Copyright (c) 2000-present Liferay, Inc. All rights reserved.
 *
 * The contents of this file are subject to the terms of the Liferay Enterprise
 * Subscription License ("License"). You may not use this file except in
 * compliance with the License. You can obtain a copy of the License by
 * contacting Liferay, Inc. See the License for the specific language governing
 * permissions and limitations under the License, including but not limited to
 * distribution rights of the Software.
 *
 *
 *
 */

package com.liferay.message.boards.kernel.service.persistence;

import aQute.bnd.annotation.ProviderType;

/**
 * @author Brian Wing Shun Chan
 * @generated
 */
@ProviderType
public interface MBMessageFinder {
	public int countByC_T(java.util.Date createDate, long threadId);

	public int countByG_U_C_S(long groupId, long userId, long[] categoryIds,
		int status);

	public int countByG_U_C_A_S(long groupId, long userId, long[] categoryIds,
		boolean anonymous, int status);

	public int filterCountByG_U_C_S(long groupId, long userId,
		long[] categoryIds, int status);

	public int filterCountByG_U_MD_C_S(long groupId, long userId,
		java.util.Date modifiedDate, long[] categoryIds, int status);

	public int filterCountByG_U_C_A_S(long groupId, long userId,
		long[] categoryIds, boolean anonymous, int status);

	public java.util.List<java.lang.Long> filterFindByG_U_C_S(long groupId,
		long userId, long[] categoryIds, int status, int start, int end);

	public java.util.List<java.lang.Long> filterFindByG_U_MD_C_S(long groupId,
		long userId, java.util.Date modifiedDate, long[] categoryIds,
		int status, int start, int end);

	public java.util.List<java.lang.Long> filterFindByG_U_C_A_S(long groupId,
		long userId, long[] categoryIds, boolean anonymous, int status,
		int start, int end);

	public java.util.List<com.liferay.message.boards.kernel.model.MBMessage> findByNoAssets();

	public java.util.List<com.liferay.message.boards.kernel.model.MBMessage> findByThreadId(
		long threadId,
		com.liferay.portal.kernel.dao.orm.QueryDefinition<com.liferay.message.boards.kernel.model.MBMessage> queryDefinition);

	public java.util.List<java.lang.Long> findByG_U_C_S(long groupId,
		long userId, long[] categoryIds, int status, int start, int end);

	public java.util.List<java.lang.Long> findByG_U_C_A_S(long groupId,
		long userId, long[] categoryIds, boolean anonymous, int status,
		int start, int end);
}